unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ImgList;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    ImageList1: TImageList;
    BitBtn3: TBitBtn;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure FormCreate(Sender: TObject); 
    procedure FormDestroy(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private

  public

  end;

var 
  Form1: TForm1;

implementation 

{$R *.DFM}

uses 
    iTray; 

//  ---------------------------------------------------------------------------
//  bZ[W
procedure   SimpleMessage(const s: string);
var
    Flag: integer;
begin
    Flag := MB_ICONINFORMATION + MB_OK;
    Application.MessageBox(PChar(s), PChar(Application.Title), Flag);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
    SimpleMessage('LeftClick');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
    SimpleMessage('LeftDblClick');
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
    SimpleMessage('RightClick');
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
    SimpleMessage('RightDblClick');
end;

//  ---------------------------------------------------------------------------
//  tH[
procedure TForm1.FormCreate(Sender: TObject);
begin 
    SimpleTray := TSimpleTaskTray.Create(Application.Icon.Handle);
    SimpleTray.FOnLeftClick     := Self.Button1.OnClick;
    SimpleTray.FOnLeftDblClick  := Self.Button2.OnClick;
    SimpleTray.FOnRightClick    := Self.Button3.OnClick;
    SimpleTray.FOnRightDblClick := Self.Button4.OnClick;
    SimpleTray.AddTray('(D(=(߁)=)D)!!');
    ListBox1.ItemIndex := 0;
end;

//  ---------------------------------------------------------------------------
//  tH[j
procedure TForm1.FormDestroy(Sender: TObject);
begin
    SimpleTray.Free();
end;

//  ---------------------------------------------------------------------------
//  o[\
procedure TForm1.BitBtn2Click(Sender: TObject);
begin
    SimpleTray.ShowBalloon(
        ListBox1.Items[ListBox1.ItemIndex],
        FormatDateTime('c', Now),
        bitWARN
    );
end;

//  ---------------------------------------------------------------------------
//  qgύX
procedure TForm1.BitBtn1Click(Sender: TObject);
begin
    SimpleTray.ModTray(ListBox1.Items[ListBox1.ItemIndex]);
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
var
    i: integer;
    Temp: TIcon;
    Icon: HICON;
begin
    Temp := TIcon.Create;
    for i := 0 to ImageList1.Count - 1 do
    begin
        ImageList1.GetIcon(i, Temp);
        Icon := Temp.Handle;
        SimpleTray.ModTray(Icon);
        Sleep(500);
    end;
    Temp.Free;
    SimpleTray.ModTray(Application.Icon.Handle);
    SimpleTray.ShowBalloon('(''A`)@޸', FormatDateTime('c', Now), bitINFO);
end;

end.

