(*

    http://www.delphi32.com/vcl/5086/
    http://subsimple.com/default.asp
    ms-help://MS.PSDK.1033/shellcc/platform/shell/reference/structures/notifyicondata.htm
    ms-help://MS.PSDK.1033/shellcc/platform/commctls/tooltip/usingtooltips.htm
    ms-help://MS.PSDK.1033/shellcc/platform/shell/programmersguide/shell_int/shell_int_programming/taskbar.htm
    http://www.wwlnk.com/boheme/delphi/tips/tec0310.htm
    http://www.borland.co.jp/qanda/delphi/d0009410.html
    http://www.swissdelphicenter.ch/torry/showcode.php?id=1164
    http://homepage1.nifty.com/MADIA/vb/vb_bbs2/200302_03020031.html
    http://vbnet.mvps.org/code/subclass/shellnotifyballoontiptimed.htm
    http://vbnet.mvps.org/code/subclass/shellnotifyballoontip.htm
    http://www2.big.or.jp/~osamu/Delphi/Tips/key.cgi?key=23#0207.txt

*)

unit iTray;

interface

uses
    Windows, Messages, SysUtils, Classes, ShellApi;

const
    NIF_INFO             = $10;
    NIF_MESSAGE          = 1;
    NIF_ICON             = 2;
    NOTIFYICON_VERSION   = 3;
    NIF_TIP              = 4;
    NIM_SETVERSION       = $00000004;
    NIM_SETFOCUS         = $00000003;
    NIIF_INFO            = $00000001;
    NIIF_WARNING         = $00000002;
    NIIF_ERROR           = $00000003;

    NIN_BALLOONSHOW      = WM_USER + 2;
    NIN_BALLOONHIDE      = WM_USER + 3;
    NIN_BALLOONTIMEOUT   = WM_USER + 4;
    NIN_BALLOONUSERCLICK = WM_USER + 5;
    NIN_SELECT           = WM_USER + 0;
    NINF_KEY             = $1;
    NIN_KEYSELECT        = NIN_SELECT or NINF_KEY;
    TRAY_CALLBACK        = WM_USER + $7258;

type
    TBalloonIconType = (bitINFO = NIIF_INFO,
                        bitWARN = NIIF_WARNING,
                        bitERROR = NIIF_ERROR);

type
    PNewNotifyIconData = ^TNewNotifyIconData;
    TDUMMYUNIONNAME = packed record
        case Integer of
            0: (uTimeout: UINT);
            1: (uVersion: UINT);
    end;

    TNewNotifyIconData = packed record 
        cbSize          : DWORD;
        Wnd             : HWND;
        uID             : UINT;
        uFlags          : UINT;
        uCallbackMessage: UINT;
        hIcon           : HICON;
        szTip           : array [0..127] of Char;   //  Windows2000 is 128 chars
        dwState         : DWORD;                    //  Windows2000
        dwStateMask     : DWORD;                    //  Windows2000
        szInfo          : array [0..255] of Char;   //  Windows2000
        DUMMYUNIONNAME  : TDUMMYUNIONNAME;
        szInfoTitle     : array [0..63] of Char;    //  Windows2000
        dwInfoFlags     : DWORD;                    //  Windows2000
    end;

type
    TSimpleTaskTray = class
    private
        FWndHandle  : HWND;
        FIconData   : TNewNotifyIconData;
        FInTray     : Boolean;
        uTaskBarRecreate: UINT;
    public
        FOnLeftClick    : TNotifyEvent;
        FOnLeftDblClick : TNotifyEvent;
        FOnRightClick   : TNotifyEvent;
        FOnRightDblClick: TNotifyEvent;

        constructor Create(const Icon: HICON);
        destructor  Destroy(); override;

        procedure   SysTrayIconMsgHandler(var Msg: TMessage);
        procedure   ClearIconData(const Icon: HICON);
        function    AddTray(const szTip: string): Boolean;
        function    ModTray(const szTip: string): Boolean; overload;
        function    ModTray(const Icon: HICON): Boolean; overload;
        function    DelTray(): Boolean;
        function    ShowBalloon(const szInfo, szInfoTitle: string;
                                     const Icon: TBalloonIconType): Boolean;
    end;

var
    SimpleTray :TSimpleTaskTray = nil;

implementation

//  ---------------------------------------------------------------------------
//  RXgN^
constructor TSimpleTaskTray.Create(const Icon: HICON);
begin
    //  V UtilWindow 쐬Au[hLXgbZ[Ŵ݂󂯎点
    uTaskBarRecreate := RegisterWindowMessage('TaskbarCreated');
    //  EBhÊӂ
    FWndHandle := Classes.AllocateHWnd(SysTrayIconMsgHandler);
    //  ^XNgCɕ\ǂ̃tO
    FInTray := false;
    ClearIconData(Icon);
end;

//  ---------------------------------------------------------------------------
//  fXgN^
destructor  TSimpleTaskTray.Destroy();
begin
    DelTray();
    //  EBhÊӂ
    Classes.DeallocateHWnd(FWndHandle);
end;

//  ---------------------------------------------------------------------------
//  EBhEvV[W
procedure   TSimpleTaskTray.SysTrayIconMsgHandler(var Msg: TMessage);
begin
    if (Msg.Msg = TRAY_CALLBACK) then
    begin
        case Msg.lParam of

        //  NbN
        WM_LBUTTONDOWN:
            if Assigned(FOnLeftClick) then FOnLeftClick(Self);

        //  _uNbN
        WM_LBUTTONDBLCLK:
            if Assigned(FOnLeftDblClick) then FOnLeftDblClick(Self);

        //  ENbN
        WM_RBUTTONDOWN:
            if Assigned(FOnRightClick) then FOnRightClick(Self);

        //  E_uNbN
        WM_RBUTTONDBLCLK:
            if Assigned(FOnRightDblClick) then FOnRightDblClick(Self);

        //  ^XNo[ړEč\zꂽ
        else
            if (Msg.lParam = LongInt(uTaskBarRecreate)) then
            begin
                if (FInTray) then
                begin
                    FInTray := false;
                    AddTray(FIconData.szTip);
                end;
            end;

        end;
    end
    else
    begin
        DefWindowProc(FWndHandle, Msg.Msg, Msg.WParam, Msg.LParam);
    end;
end;

//  ---------------------------------------------------------------------------
//  \̏
procedure   TSimpleTaskTray.ClearIconData(const Icon: HICON);
begin
    FillChar(FIconData, SizeOf(FIconData), 0);
    FIconData.cbSize := SizeOf(FIconData);
    FIconData.Wnd := FWndHandle;
    FIconData.uID := 0;
    FIconData.uCallbackMessage := TRAY_CALLBACK;
    FIconData.hIcon := Icon;
end;

//  ---------------------------------------------------------------------------
//  ^XNgCɃACR\
function    TSimpleTaskTray.AddTray(const szTip: string): Boolean;
begin
    if (FInTray) then
    begin
        Result := true;
    end
    else
    begin
        FIconData.uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP;
        strPLCopy(FIconData.szTip, szTip, SizeOf(FIconData.szTip) - 1);
        Result := Shell_NotifyIcon(NIM_ADD, @FIconData);
    end;
    FInTray := Result;
end;

//  ---------------------------------------------------------------------------
//  ^XNgC̃`bvXύX
function    TSimpleTaskTray.ModTray(const szTip: string): Boolean;
begin
    if (FInTray) then
    begin
        FIconData.uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP;
        strPLCopy(FIconData.szTip, szTip, SizeOf(FIconData.szTip) - 1);
        Result := Shell_NotifyIcon(NIM_MODIFY, @FIconData);
    end
    else
    begin
        Result := false;
    end;
end;

//  ---------------------------------------------------------------------------
//  ^XNgC̃ACRύX
function    TSimpleTaskTray.ModTray(const Icon: HICON): Boolean;
begin
    if (FInTray) then
    begin
        FIconData.uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP;
        FIconData.hIcon := Icon;
        Result := Shell_NotifyIcon(NIM_MODIFY, @FIconData);
    end
    else
    begin
        Result := false;
    end;
end;

//  ---------------------------------------------------------------------------
//  ^XNgCACR
function    TSimpleTaskTray.DelTray(): Boolean;
begin
    if (FInTray) then
    begin
        Result := Shell_NotifyIcon(NIM_DELETE, @FIconData);
    end
    else
    begin
        Result := true;
    end;
end;

//  ---------------------------------------------------------------------------
//  o[wv\
function    TSimpleTaskTray.ShowBalloon(const szInfo, szInfoTitle: string;
                             const Icon: TBalloonIconType): Boolean;
begin
    if (FInTray) then
    begin
        FIconData.uFlags := NIF_INFO;
        strPLCopy(FIconData.szInfo, szInfo, SizeOf(FIconData.szInfo) - 1);
        FIconData.DUMMYUNIONNAME.uTimeout := 3000;
        strPLCopy(FIconData.szInfoTitle, szInfoTitle, SizeOf(FIconData.szInfoTitle) - 1);
        FIconData.dwInfoFlags := Integer(Icon);
        Shell_NotifyIcon(NIM_MODIFY, @FIconData);
        //  C
        FIconData.DUMMYUNIONNAME.uVersion := NOTIFYICON_VERSION;
        Result := Shell_NotifyIcon(NIM_SETVERSION, @FIconData);
    end
    else
    begin
        Result := false;
    end;
end;

end.

